# -*- coding: utf-8 -*-
#
# VARAMMA documentation build configuration file, created by
# sphinx-quickstart on Wed Mar 24 16:54:51 2010.
#
# This file is execfile()d with the current directory set to its containing dir.
#
# Note that not all possible configuration values are present in this
# autogenerated file.
#
# All configuration values have a default; values that are commented out
# serve to show the default.
#+
#
# TODO
# ====
#
# - fplod 20100618T151933Z aedon.locean-ipsl.upmc.fr (Darwin)
#
#   * find a way to produce olr_split.sh.1 even if graphviz inside source
#   * find a way to avoid hard coded man pages name here (should be in
#     adm/makefile)
#   * use a specific index.rst for man troff
#
# - fplod 20100610T135910Z aedon.locean-ipsl.upmc.fr (Darwin)
#
#   * how to detected "Deprecated" sphinx features (this file was created
#     using sphinx 0.6.5 or less
#
# EVOLUTIONS
# ==========
#
# $Id$
#
# - fplod 20110610T075315Z aedon.locean-ipsl.upmc.fr (Darwin)
#
#   * graphviz attributes (cf. http://sphinx.pocoo.org/ext/inheritance.html#confval-inheritance_graph_attrs)
#
# - fplod 20101217T163402Z aedon.locean-ipsl.upmc.fr (Darwin)
#
#   * intersphinx with saxo
#     cf. http://sphinx.pocoo.org/ext/intersphinx.html
#
# - fplod 20100618T151856Z aedon.locean-ipsl.upmc.fr (Darwin)
#
#   * produce man page for almost all shell scripts
#
# - fplod 20100610T123554Z aedon.locean-ipsl.upmc.fr (Darwin)
#
#   * add Options for manual page output (Sphinx 1.0 required)
#
# - fplod 20100608T151729Z aedon.locean-ipsl.upmc.fr (Darwin)
#
#   * add graphviz extension (Sphinx 0.6.6 required)
#
#-

import sys, os

# If extensions (or modules to document with autodoc) are in another directory,
# add these directories to sys.path here. If the directory is relative to the
# documentation root, use os.path.abspath to make it absolute, like shown here.
#sys.path.insert(0, os.path.abspath('.'))
sys.path.insert(0, os.path.abspath('../../../src/'))

# -- General configuration -----------------------------------------------------

# Add any Sphinx extension module names here, as strings. They can be extensions
# coming with Sphinx (named 'sphinx.ext.*') or your custom ones.
#extensions = ['sphinx.ext.intersphinx', 'sphinx.ext.todo', 'sphinx.ext.coverage', 'sphinx.ext.pngmath', 'sphinx.ext.ifconfig']
extensions = ['sphinx.ext.autodoc',
	      'sphinx.ext.doctest',
              'sphinx.ext.todo',
	      'sphinx.ext.intersphinx',
	      'sphinx.ext.coverage',
	      'sphinx.ext.pngmath',
	      'sphinx.ext.ifconfig',
	      'sphinx.ext.viewcode',
	      'sphinx.ext.graphviz',
	      'sphinx.ext.inheritance_diagram' ]

# Add any paths that contain templates here, relative to this directory.
templates_path = ['_templates']

# The suffix of source filenames.
source_suffix = '.rst'

# The encoding of source files.
source_encoding = 'iso-8859-15'

# The master toctree document.
master_doc = 'index'

# General information about the project.
project = u'VARAMMA'
copyright = u'2008, 2009, 2010, 2011, 2012, CNRS'

# The version info for the project you're documenting, acts as replacement for
# |version| and |release|, also used in various other places throughout the
# built documents.
#
# The short X.Y version.
version = '1.0.0'
# The full version, including alpha/beta/rc tags.
release = '1.0.0'

# The language for content autogenerated by Sphinx. Refer to documentation
# for a list of supported languages.
#language = None

# There are two options for replacing |today|: either, you set today to some
# non-false value, then it is used:
#today = ''
# Else, today_fmt is used as the format for a strftime call.
#today_fmt = '%Y%m%d'

# List of directories, relative to source directory, that shouldn't be searched
# for source files.
exclude_patterns = ['_build']

# The reST default role (used for this markup: `text`) to use for all documents.
#default_role = None

# If true, '()' will be appended to :func: etc. cross-reference text.
#add_function_parentheses = True

# If true, the current module name will be prepended to all description
# unit titles (such as .. function::).
add_module_names = True

# If true, sectionauthor and moduleauthor directives will be shown in the
# output. They are ignored by default.
#show_authors = False

# The name of the Pygments (syntax highlighting) style to use.
pygments_style = 'sphinx'

# A list of ignored prefixes for module index sorting.
#modindex_common_prefix = []

todo_include_todos = True

# graphviz attributes
inheritance_graph_attrs = dict(rankdir="LR", size='"6.0, 8.0"',
                               fontsize=14, ratio='compress')

# Warn about all references where the target cannot be found.
nitpicky = True

# -- Options for HTML output ---------------------------------------------------

# The theme to use for HTML and HTML Help pages.  Major themes that come with
# Sphinx are currently 'default' and 'sphinxdoc'.
html_theme = 'default'

# Theme options are theme-specific and customize the look and feel of a theme
# further.  For a list of options available for each theme, see the
# documentation.
#html_theme_options = {}

# Add any paths that contain custom themes here, relative to this directory.
#html_theme_path = []

# The name for this set of Sphinx documents.  If None, it defaults to
# "<project> v<release> documentation".
#html_title = None

# A shorter title for the navigation bar.  Default is the same as html_title.
#html_short_title = None

# The name of an image file (relative to this directory) to place at the top
# of the sidebar.
#html_logo = None

# The name of an image file (within the static path) to use as favicon of the
# docs.  This file should be a Windows icon file (.ico) being 16x16 or 32x32
# pixels large.
#html_favicon = None

# Add any paths that contain custom static files (such as style sheets) here,
# relative to this directory. They are copied after the builtin static files,
# so a file named "default.css" will overwrite the builtin "default.css".
html_static_path = ['_static']

# If not '', a 'Last updated on:' timestamp is inserted at every page bottom,
# using the given strftime format.
#html_last_updated_fmt = '%b %d, %Y'

# If true, SmartyPants will be used to convert quotes and dashes to
# typographically correct entities.
#html_use_smartypants = True

# Custom sidebar templates, maps document names to template names.
#html_sidebars = {}

# Additional templates that should be rendered to pages, maps page names to
# template names.
#html_additional_pages = {}

# If false, no module index is generated.
#html_domain_indices = True

# If false, no index is generated.
#html_use_index = True

# If true, the index is split into individual pages for each letter.
#html_split_index = False

# If true, links to the reST sources are added to the pages.
#html_show_sourcelink = True

#html_show_sphinx = True
#html_show_copyright = True

# If true, an OpenSearch description file will be output, and all pages will
# contain a <link> tag referring to it.  The value of this option must be the
# base URL from which the finished HTML is served.
#html_use_opensearch = ''

# If nonempty, this is the file name suffix for HTML files (e.g. ".xhtml").
#html_file_suffix = ''

# Output file base name for HTML help builder.
htmlhelp_basename = 'VARAMMAdoc'


# -- Options for LaTeX output --------------------------------------------------

# The paper size ('letter' or 'a4').
#latex_paper_size = 'letter'

# The font size ('10pt', '11pt' or '12pt').
#latex_font_size = '10pt'

# Grouping the document tree into LaTeX files. List of tuples
# (source start file, target name, title, author, documentclass [howto/manual]).
latex_documents = [
  ('index', 'varamma_dev.tex', u'VARAMMA developpers documentation',
   u'CNRS', 'manual'),
]

# The name of an image file (relative to this directory) to place at the top of
# the title page.
#latex_logo = None

# For "manual" documents, if this is true, then toplevel headings are parts,
# not chapters.
#latex_use_parts = False

# Additional stuff for the LaTeX preamble.
#latex_preamble = ''

# Documents to append as an appendix to all manuals.
#latex_appendices = []

# If false, no module index is generated.
#latex_domain_indices = True


# -- Options for manual page output --------------------------------------------

# One entry per manual page. List of tuples
# (source start file, name, description, authors, manual section).
man_pages = [
    ('index', project, u'VARAMMA developpers documentation', [u'fp'], 1),
    ('cat_clim_ecmwf.sh', 'cat_clim_ecmwf.sh', u'cat_clim_ecmwf.sh Documentation', [u'fp'], 1),
    ('cat_clim_olr.sh', 'cat_clim_olr.sh', u'cat_clim_olr.sh Documentation', [u'fp'], 1),
    ('create_gif.sh', 'create_gif.sh', u'create_gif.sh Documentation', [u'fp'], 1),
    ('concat-files.sh', 'concat-files.sh', u'concat-files.sh Documentation', [u'fp'], 1),
    ('create_nc.sh', 'create_nc.sh', u'create_nc.sh Documentation', [u'fp'], 1),
    ('dlogd.sh', 'dlogd.sh', u'dlogd.sh Documentation', [u'fp'], 1),
    ('elogd.sh', 'elogd.sh', u'elogd.sh Documentation', [u'fp'], 1),
    ('plogd.sh', 'plogd.sh', u'plogd.sh Documentation', [u'fp'], 1),
    ('tlogd.sh', 'tlogd.sh', u'tlogd.sh Documentation', [u'fp'], 1),
    ('is_leap_year.sh', 'is_leap_year.sh', u'is_leap_year.sh Documentation', [u'fp'], 1),
    ('olr_split.sh', 'olr_split.sh', u'olr_split.sh Documentation', [u'fp'], 1),
    ('paper01_pre.sh', 'paper01_pre.sh', u'paper01_pre.sh Documentation', [u'fp'], 1),
    ('traite_amsuab.sh', 'traite_amsuab.sh', u'traite_amsuab.sh Documentation', [u'fp'], 1),
    ('traite_msg-prod.sh', 'traite_msg-prod.sh', u'traite_msg-prod.sh Documentation', [u'fp'], 1),
    ('varamma_profile.sh', 'varamma_profile.sh', u'varamma_profile.sh Documentation', [u'fp'], 1),
    ('script_cat_climeraint2d.sh', 'script_cat_climeraint2d.sh', u'script_cat_climeraint2d.sh Documentation', [u'fp'], 1),
    ('get_msg.sh', 'get_msg.sh', u'get_msg.sh Documentation', [u'fp'], 1),
    ('get_amsu.sh', 'get_amsu.sh', u'get_amsu.sh Documentation', [u'fp'], 1),
    ('extract_zone_nc.sh', 'extract_zone_nc.sh', u'extract_zone_nc.sh Documentation', [u'fp'], 1),
]

# intersphinx with saxo
intersphinx_mapping = {'saxo': ('http://forge.ipsl.jussieu.fr/saxo/download/idldoc_html_output/','saxo.inv'),
		'fptools' : ('http://www.locean-ipsl.upmc.fr/~fplod/fptools/fptools_ws/doc/html/', None)}
