; docformat = 'rst'
;+
;
; .. _figure01.pro:
;
; ============
; figure01.pro
; ============
;
; plot figure 1 of paper1
;
; :Categories: figure
;
; :Uses:
;  :ref:`hovmuller.pro`
;
; :Restrictions:
;
; :Pre:
;  :ref:`varamma_profile.sh`
;
;  for AMSU dataset be sure to have :file:`{c}{x}.an{yyyy}.nc`
;  in the directory defined in :file:`${PROJECT_ID}/` 
;
; :Post:
;  :ref:`varamma_profile.sh`
;
; :Todo:
;
;
; :Examples:
;
; ::
;
;    figure01
;
; :History:
;
;  $Id: figure01.pro 215 2011-04-26 10:33:10Z pinsard $
;
; - fplod 2009-05-14T15:38:53Z aedon.locean-ipsl.upmc.fr (Darwin)
;
;   * taking into account :ref:`hovmuller.pro` new timebox keyword
;
; - fplod 2008-12-23T15:47:59Z aedon.locean-ipsl.upmc.fr (Darwin)
;
;   * add ubox keywords required by hovmuller.pro
;
; - fplod 2008-08-12T13:30:02Z aedon.locean-ipsl.upmc.fr (Darwin)
;
;   * creation of header not yet ok, just the idea
;
;-
pro figure01
;
compile_opt idl2, strictarrsubs
@cm_project
;
hovmuller, 'AMSU', 'a4', timebox=[20060401L,20061031L], ubox=[-30.,+40.,-30.,45.], small=[2,8,1]
hovmuller, 'AMSU', 'a5', timebox=[20060401L,20061031L], ubox=[-30.,+40.,-30.,45.], small=[2,8,2],/noerase
hovmuller, 'AMSU', 'a6', timebox=[20060401L,20061031L], ubox=[-30.,+40.,-30.,45.], small=[2,8,3],/noerase
hovmuller, 'AMSU', 'a7', timebox=[20060401L,20061031L], ubox=[-30.,+40.,-30.,45.], small=[2,8,4],/noerase
hovmuller, 'AMSU', 'b3', timebox=[20060401L,20061031L], ubox=[-30.,+40.,-30.,45.], small=[2,8,5],/noerase
hovmuller, 'AMSU', 'b4', timebox=[20060401L,20061031L], ubox=[-30.,+40.,-30.,45.], small=[2,8,6],/noerase
hovmuller, 'AMSU', 'b5', timebox=[20060401L,20061031L], ubox=[-30.,+40.,-30.,45.], small=[2,8,7],/noerase
saveimage, fullfilename_out,/png
end
