; docformat = 'rst'
;+
; .. _map_amab.pro:
;
; ============
; map_amab.pro
; ============
;
; :Param:
;   amafile
;   ambfile
;   dam
;   jour_ama
;   flagg
;   lonmin
;   lonmax
;   latmin
;   latmax
;
; :Uses:
;
; :Restrictions:
;
; :Pre:
;
; :Post:
;
; :Todo:
;
; revoir les tableaux dam dimension et index = f(use*) : 25 en dur 5-24 en dur
;
; NaN vs -999
;
; why crash when compile_opt idl2, strictarrsubs !!
;
; :Examples:
;
; ::
;
;    use_amsua=0
;    use_amsub=1
;    amafile=project_id_env+"/AMSUAN15/L1C/2006/2006_08_01/NSS.AMAX.NK.D06213.S0110.E0255.B4271112.GC.L1C"
;    ambfile=project_id_env+"/AMSUBN15/L1C/2006/2006_08_01/NSS.AMBX.NK.D06213.S0110.E0255.B4271112.GC.L1C"
;    lonmin=-60.
;    lonmax=50
;    latmin=-30
;    latmax=45
;    map_amab, use_amsua, use_amsub, amafile,ambfile,dam,jour_ama,flagg,lonmin,lonmax,latmin,latmax
;    print, dam
;    print, jour_ama
;    print, flagg
;
; :History:
;
;  $Id: map_amab.pro 253 2011-05-25 17:09:18Z lelod $
;
; - pinsard 2011-05-16T15:34:01Z loholt1.ipsl.polytechnique.fr (Linux)
;
;   * replace some () by [] but not ok with compile_opt idl2, strictarrsubs
;
; - fplod 20100701T130054Z aedon.locean-ipsl.upmc.fr (Darwin)
;
;   * minimal header
;
;-
PRO map_amab,use_amsua, use_amsub, amafile,ambfile,dam,jour_ama,flagg,lonmin,lonmax,latmin,latmax
;
;++compile_opt idl2, strictarrsubs
;

if (use_amsua EQ 1) THEN BEGIN
COMMON amsua_header,ama_head
COMMON amsua_data  ,ama_scan
   read_amsua1c,amafile, flag1
   if (flag1 eq 0) then goto, nopoints
   na=SIZE(reform(ama_scan.btemps[0,*,*])) 
   na_scan=na[2]    ; nb lignes (fauchees) dans l'orbite
   na_fov=na[1]     ; nb points dans la fauchee
   satt_ide=ama_head.h_satid
   tt=REFORM(ama_scan.scnlintime/3600000.)
ENDIF
if (use_amsub EQ 1) THEN BEGIN
   amafile=[0]  ; est-ce possible de faire cela???
   COMMON amsub_header,amb_head
   COMMON amsub_data  ,amb_scan
   read_amsub1c,ambfile, flag2
   if (flag2 eq 0) then goto, nopoints
   nb=SIZE(reform(amb_scan.btemps[0,*,*])) 
   nb_scan=nb[2]
   nb_fov=nb[1]
   satt_ide=amb_head.h_satid
   tt=REFORM(amb_scan.scnlintime/3600000.)
ENDIF

nbpix_a = 30  ; nb pixels dans la fauchee AMSUA = na_fov
nbpix_b = 90  ; nb pixels dans la fauchee AMSUB = nb_fov


; selection des lignes amsub qui minimisent la distance avec le centre
; des lignes amsua 
get_sync_pulse, use_amsua, pulse_line, descending   ; fonction qui cherche les pixels AMSUB qui minimisent la distance avec ceux d'AMSUA
bsync=where(pulse_line GT 0)    ; si use_amsua=0 alors pulse_line contient toutes les lignes amsub, entrees dans async
async=pulse_line[bsync]


fovb=indgen(nbpix_b - 1 ) + 1
;   cette fois on travaille sur la fauchee
if (use_amsua EQ 1 ) AND (use_amsub EQ 1) THEN BEGIN
   sfo=where((fix(fovb+1) mod 3) eq 0)
   fov=fovb[sfo]
   nbpix= nbpix_a
   n=na
   n_scan=na_scan
   n_fov=na_fov
   naa_scan=n_elements(bsync)
                             
ENDIF ELSE BEGIN
   fov=fovb
   nbpix= nbpix_b
   n=nb
   n_scan=nb_scan
   n_fov=nb_fov
   ; on garde tous les points
ENDELSE

;print,'step4'
;-------------------------------------------------------------------
;
; choix d'un pixel amsub sur 3 et une ligne synchronisee avec amsua
;
;-------------------------------------------------------------------

ntime_1=fltarr(nbpix,n_scan)
fovy_1=fltarr(nbpix,n_scan)
for i=0L, n_scan-1L do begin
    ntime_1[*,i]=tt[i]
endfor

for j=0L, nbpix-1L do begin
    fovy_1[j,*]=j+1
endfor
; on lit la structure et on extrait les infos: temps, longitude,
; latitude, et les Tbs des differents canaux (15 pour AMSUA, 5 pour AMSUB)
bmch1_1=REFORM(amb_scan.btemps[0,*,*]/100.)
bmch2_1=REFORM(amb_scan.btemps[1,*,*]/100.)
bmch3_1=REFORM(amb_scan.btemps[2,*,*]/100.)
bmch4_1=REFORM(amb_scan.btemps[3,*,*]/100.)
bmch5_1=REFORM(amb_scan.btemps[4,*,*]/100.)


bmzen_1=REFORM(amb_scan.angles[0,*,*]/100.)
bmlat_1=REFORM(amb_scan.latlon[0,*,*]/1.E4)
bmlon_1=REFORM(amb_scan.latlon[1,*,*]/1.E4)

;    si use_amsua=0 tout cela se reduit a b*=b*_1 et c'est tout
if (use_amsua eq 0) then begin
   bmzen=bmzen_1
   bmlat=bmlat_1
   bmlon=bmlon_1
   bmch1=bmch1_1
   bmch2=bmch2_1
   bmch3=bmch3_1
   bmch4=bmch4_1
   bmch5=bmch5_1

  amzen_1=REFORM(amb_scan.angles[0,*,*]/100.)
    amazen=amzen_1[*,async]
    amlat_1=REFORM(amb_scan.latlon[0,*,*]/1.E4)
    amlon_1=REFORM(amb_scan.latlon[1,*,*]/1.E4)
    amalat=amlat_1
    amalon=amlon_1
    amtime_1=REFORM(amb_scan.scnlintime/3600000.)
    amday_1=REFORM(amb_scan.scnlindy)
    amatime=amtime_1
    amaday=amday_1
 endif else begin
   bmzen_2=bmzen_1[fov,*]
   bmzen=bmzen_2[*,bsync]
   bmlat_2=bmlat_1[fov,*]
   bmlon_2=bmlon_1[fov,*]
   bmlat=bmlat_2[*,bsync]
   bmlon=bmlon_2[*,bsync]
   bmch1_2=bmch1_1[*,bsync]
   bmch1=bmch1_2[fov,*]
   bmch2_2=bmch2_1[*,bsync]
   bmch2=bmch2_2[fov,*]
   bmch3_2=bmch3_1[*,bsync]
   bmch3=bmch3_2[fov,*]
   bmch4_2=bmch4_1[*,bsync]
   bmch4=bmch4_2[fov,*]
   bmch5_2=bmch5_1[*,bsync]
   bmch5=bmch5_2[fov,*]

    amch1_1=REFORM(ama_scan.btemps[0,*,*]/100.)
    amch2_1=REFORM(ama_scan.btemps[1,*,*]/100.)
    amch3_1=REFORM(ama_scan.btemps[2,*,*]/100.)
    amch4_1=REFORM(ama_scan.btemps[3,*,*]/100.)
    amch5_1=REFORM(ama_scan.btemps[4,*,*]/100.)
    amch6_1=REFORM(ama_scan.btemps[5,*,*]/100.)
    amch7_1=REFORM(ama_scan.btemps[6,*,*]/100.)
    amch8_1=REFORM(ama_scan.btemps[7,*,*]/100.)
    amch9_1=REFORM(ama_scan.btemps[8,*,*]/100.)
    amch10_1=REFORM(ama_scan.btemps[9,*,*]/100.)
    amch11_1=REFORM(ama_scan.btemps[10,*,*]/100.)
    amch12_1=REFORM(ama_scan.btemps[11,*,*]/100.)
    amch13_1=REFORM(ama_scan.btemps[12,*,*]/100.)
    amch14_1=REFORM(ama_scan.btemps[13,*,*]/100.)
    amch15_1=REFORM(ama_scan.btemps[14,*,*]/100.)

    amch1=amch1_1[*,async]
    amch2=amch2_1[*,async]
    amch3=amch3_1[*,async]
    amch4=amch4_1[*,async]
    amch5=amch5_1[*,async]
    amch6=amch6_1[*,async]
    amch7=amch7_1[*,async]
    amch8=amch8_1[*,async]
    amch9=amch9_1[*,async]
    amch10=amch10_1[*,async]
    amch11=amch11_1[*,async]
    amch12=amch12_1[*,async]
    amch13=amch13_1[*,async]
    amch14=amch14_1[*,async]
    amch15=amch15_1[*,async]

    amzen_1=REFORM(ama_scan.angles[0,*,*]/100.)
    amazen=amzen_1[*,async]

    amlat_1=REFORM(ama_scan.latlon[0,*,*]/1.E4)
    amlon_1=REFORM(ama_scan.latlon[1,*,*]/1.E4)

    amalat=amlat_1[*,async]
    amalon=amlon_1[*,async]

    amtime_1=REFORM(ama_scan.scnlintime/3600000.)
    amday_1=REFORM(ama_scan.scnlindy)

    amatime=amtime_1(async)
    amaday=amday_1(async)
  
 ENDELSE

amfov= fovy_1[*,async]
ntime=ntime_1[*,async]
jour_ama=amaday[0]
;-----------------
; ici on selectionne la zone definie
; on elimine les donnees non valides
;-----------------

tbmin=100
tbmax=350

;;on definit ici par precaution contre les donnees erronees seulement la zone geographique

zone=where((amalon ge lonmin) and (amalon le lonmax) $
             and (amalat ge latmin) and (amalat le latmax) )

nn=n_elements(zone)
if (nn GT 10) then begin
    flagg=1
    dam=fltarr(25,nn)
    dam[0,*]=amalon[zone]
    dam[1,*]=amalat[zone]
    dam[2,*]=amazen[zone]
    dam[3,*]=amfov[zone]
    dam[4,*]=amatime[zone]
    IF (use_amsua EQ 1) THEN BEGIN
        dam[5,*]=amch1[zone]
        dam[6,*]=amch2[zone]
        dam[7,*]=amch3[zone]
        dam[8,*]=amch4[zone]
        dam[9,*]=amch5[zone]
        dam[10,*]=amch6[zone]
        dam[11,*]=amch7[zone]
        dam[12,*]=amch8[zone]
        dam[13,*]=amch9[zone]
        dam[14,*]=amch10[zone]
        dam[15,*]=amch11[zone]
        dam[16,*]=amch12[zone]
        dam[17,*]=amch13[zone]
        dam[18,*]=amch14[zone]
        dam[19,*]=amch15[zone]
    ENDIF

    dam[20,*]=bmch1[zone]
    dam[21,*]=bmch2[zone]
    dam[22,*]=bmch3[zone]
    dam[23,*]=bmch4[zone]
    dam[24,*]=bmch5[zone]

    ; on reeaffecte les donnees erronees a la valeur -999.

    for j=0L,nn-1L do begin
        for i=5L,24L do begin
            if (( dam[i,j] lt tbmin) or (dam[i,j] gt tbmax) ) then begin
        	dam[i,j]=-999.
            endif
        endfor
    endfor

  endif else begin
	nopoints:
    flagg=0
    print, 'pas de points dans la zone'
endelse

return
end
