; docformat = 'rst'
;+
;.. _nuage.pro:
;
; =========
; nuage.pro
; =========
;
; DESCRIPTION
; ===========
;
; Programme d'analyse des nuages avec MSG et AMSU - version LE sur skylla
;
; ajout d'un rebouchage des trous dus a l'ajustement des pixels AMSU
; sur la grille MSG (plus proche voisin, pas de prise en compte
; de l'elargissement de la grille avec l'angle)
;
; SEE ALSO
; ========
;
; :ref:`guide data MSG <data_msg>`
;
; TODO
; ====
;
; new terminology
;
; EVOLUTIONS
; ==========
;
; $Id: nuage.pro 215 2011-04-26 10:33:10Z pinsard $
;
; $URL$
;
; - fplod 20100810T145755Z aedon.locean-ipsl.upmc.fr (Darwin)
;
;   * minimal rst header
;
;-

;dataset='MSG'
; uncomment following line to work with AMSU datafiles
;dataset='AMSU'
;CASE dataset OF

;   'AMSU': BEGIN
 ;     name='amsubch5-noaa17_20060801-000722_afratl_Nadir.nc'
      path='/Users/lelod/dossiers/progX11/My_IDL/stagiaire/nuages/'
      name='amsubch5-noaa15_20060813-064214_afratl_Nadir.nc'
      file=path+name
      initncdf, file, xaxisname = 'longitude', yaxisname = 'latitude'
      lon1=-25 & lon2=25 & lat1=-5 & lat2=20
      domdef,lon1,lon2,lat1,lat2
      data=read_ncdf('tbch5b',0,0,/timestep,timevar='time',file = file)
;      lat=read_ncdf('lat',0,0,/timestep,timevar='time',file = file)
;      lon=read_ncdf('lon',0,0,/timestep,timevar='time',file = file)
      s=size(data.arr,/DIMENSIONS)
      nblon=s[0]
      nblat=s[1]
      ; ++ close
      date=strmid(name,16,8)
      heure=strmid(name,25,6)
     ; wl=smooth(data.arr,100,/edge_truncate)
      tbamsu=data.arr
;     tentative pour boucher les trous dans la glille AMSU
;     masque des donnees valides
      mask=bytarr(nblon,nblat)
      for j=0,nblat-1 do begin
        ind=where(finite(tbamsu(*,j)) eq 1,nb)
        indmin=ind(0) & indmax=ind(nb-1)
        mask(indmin:indmax,j)=1
      endfor
      tbplein=extrapolate(tbamsu,finite(tbamsu),10) ;extrapole lineairement a partir des donnees bonnes 
;      entourant le trou, donc extrapole aussi en dehors de la zone de l'orbite
      tbplein(where(mask eq 0))=!values.f_nan ; remet en Nan les donnees exterieures a l'orbite

      seuil=270.
      ; show AMSU data
     plt,tbplein,window=0,/realcont,/cont_nofill,title='TB AMSU',/rempli,/nocontour
;      goto, detection
;   'MSG' : BEGIN
;      name='msg-tb108_2006-08-01_15min.nc'
      path='/Users/lelod/dossiers/progX11/My_IDL/stagiaire/nuages/'

;     path="/net/zeus/usr/zeus/incas/mousson/MSG"  pour travail sur zeus
      name='msg-tb108_2006-08-13_15min.nc'
      file=path+name
      initncdf, file, xaxisname = 'longitude', yaxisname = 'latitude'
      lon1=-25 & lon2=25 & lat1=-5 & lat2=20
    ;  lon1=15 & lon2=20 & lat1=7 & lat2=12
      domdef,lon1,lon2,lat1,lat2
      h1=23 & h2=23   ; en principe, la meme heure que AMSU
      data=read_ncdf('DATA', h1,h2,/timestep,timevar = 'time', file = file)
      ; ++ close
      ; time information
      date=strmid(name,50,50)
      ; +todo+ heure inside data
      wl=smooth(data.arr,10,/edge_truncate,/nan)
      threshold=239.
      s=size(wl,/DIMENSIONS)
      ni=s[0]
      ll=s[1]
      print,ni,ll
      ;tb22v=fltarr(ni,ll)+1.
     ; wv=fltarr(ni,ll)
     ;us=fltarr(ni,ll)
      ; show MSG data
     ; CONTOUR, wl,NLEVELS=1
      ind=where(wl gt threshold)
     wl(ind)=0
     loadct,39
      plt,wl,window=1,/realcont,/cont_nofill,title='TB MSG',/rempli,/nocontour,min=200

;      goto, detection
;   END
;ENDCASE


;ENDIF

;extraction des nuages
;detection:
print,'on attaque les nuages'
; utilisation de la fonction idl qui fait le travail toute seule!
cloud=wl
ind=where(wl ne 0)
cloud(ind)=1
nuag=label_region(cloud)
zut=1
if zut eq 1 then goto,labfin
; methode LE initiale
ncloud_max=5000
nuag=intarr(ni,ll)
nu=0
FOR j=0,ll-1 DO BEGIN
   ;print, j
   FOR i=0,(ni-1) DO BEGIN
      IF (wl(i,j) gt 0 and wl(i,j) lt threshold) THEN BEGIN
         nuage=nuag((i-1)>0:(i+1)<(ni-1),(j-1)>0:j)
         ind=where(nuage gt 0,nb)
         IF (nb eq 0) THEN BEGIN
            nu=nu+1
            nuag(i,j)=nu
           ; print,'nouveau nuage',nu,i,j
         ENDIF
         IF (nb ne 0) THEN BEGIN
            nuag(i,j)=min(nuage(ind))
            FOR kj=0>(j-1),j DO BEGIN
                FOR ki=0>(i-1),(i+1)<(ni-1) DO BEGIN
                   IF (nuag(ki,kj) ne 0) THEN BEGIN
                      nuag(ki,kj)=nuag(i,j)
                   ENDIF
                ENDFOR
            ENDFOR
         ENDIF
        ; print , 'detection',i,j,nuag(i,j),wl(i,j)
      ENDIF
   ENDFOR
ENDFOR
print,'nb nuages',max(nuag)
;on a numerote les nuages. Recherche des affectations abusives

FOR j=0,ll-1 DO BEGIN
    FOR i=0,(ni-1) DO BEGIN
      IF (nuag(i,j) gt 0) THEN BEGIN
         nu=nuag(i,j)
         cloud=nuag((i-1)>0:(i+1)<(ni-1),(j-1)>0:(j+1)<(ll-1))
         kid=where(cloud eq nu,nbi)
         kdi=where((cloud ne nu) and (cloud ne 0),nbd)
         IF nbd ne 0 THEN BEGIN       
          ;  nuag(i,j)=min(cloud(kdi))
            ind=where(nuag eq nu)
             nuag(ind)=min(cloud(kdi))
         ENDIF
      ENDIF
   ENDFOR
 ENDFOR


labfin:
numax=max(nuag)

; show clouds detected
;CONTOUR, nuag,NLEVELS=1
nuagplot=nuag
test=where(nuag ne 0)
nuagplot(test)=nuag(test)+10
;loadct,18
plt,nuagplot,window=2,/realcont,/cont_nofill,title='nuages MSG',/rempli,/nocontour,min=min(nuagplot),max=max(nuagplot)
;Moyennes et ecarts types dans les nuages
compt=intarr(numax)
lmoy=fltarr(numax)
lstd=fltarr(numax)
tbmoy=fltarr(numax)

knu=0
nu=1
labnu:
;ind=where(nuag eq nu,nb)
ind=where((nuag eq nu) and (wl gt 0.),nb)
IF nb ne 0 THEN BEGIN
  compt(knu)=nb  ; nb pixels
  lmoy(knu)=mean(wl(ind))
  tb=tbamsu(ind)
  jnd=where(finite(tb) eq 1,nn)
  if nn ne 0 then tbmoy(knu)=mean(tb(jnd))
  IF (nb gt 1) THEN BEGIN
     lstd(knu)=stddev(wl(ind))
  ENDIF
print,knu,nb,lmoy(knu),tbmoy(knu)
  knu=knu+1
ENDIF
nu=nu+1
IF nu le numax THEN BEGIN
   goto,labnu
ENDIF

IF ( knu gt 0 ) THEN BEGIN
;   print,'nb nuages',knu,mean(compt),mean(lmoy),mean(tbmoy)

ENDIF ELSE BEGIN
   print, '0 nuage !',numax
ENDELSE
end

