function[ppt_moy, ppt_ecartyp,Latzone,Longzone]=plot_cartes3B42(annee)

%+
% _plot_cartes3B42.m:
%
% =================
% plot_cartes3B42.m
% =================
%
%-

global PROJECT_ID
global netcdf_open_available
% Parametres
latmin=14.30;
latmax=16.15;
lonmin=-16;
lonmax=-12.50;
usage='[ppt_moy, ppt_ecartyp]=plot_cartes3B42(annee)';
%
if nargin~=nargin(mfilename)
   disp(['Incorrect number of input arguments' num2str(nargin)])
   error(usage);
end
%
if nargout~=nargout(mfilename);
   disp(['Incorrect number of output arguments' num2str(nargout)])
   error(usage);
end
%
%arg_info=whos('annee');
%if ~strcmp(arg_info.class,'uint16')
%    disp(['Incorrect type of arg annee ' arg_info.class]);
%    error(usage);
%end
%clear arg_info
%
%arg_info=whos('mois');
%if ~strcmp(arg_info.class,'uint16')
%    disp(['Incorrect type of arg mois ' arg_info.class]);
%    error(usage);
%end
%clear arg_info
%
%arg_info=whos('jour');
%if ~strcmp(arg_info.class,'uint16')
%    disp(['Incorrect type of arg jour ' arg_info.class]);
%    error(usage);
%end
%clear arg_info
%
fullfilename=[ PROJECT_ID '3B42/3B42_daily.' int2str(annee) '.Afr_025.nc']
disp(['iii : opening for reading ', fullfilename])
% ouverture du fichier
if netcdf_open_available
   ncid=netcdf.open(fullfilename, 'NC_NOWRITE');
   disp(['iii : netcdf open' ]);
else
   ncid=netcdf(fullfilename, 'nowrite');
end
clear fullfilename
% récupération des variables
if netcdf_open_available
   Temps=netcdf.getVar(ncid,0);
   Latitude=netcdf.getVar(ncid,1);
   Longitude=netcdf.getVar(ncid,2);
else
   Temps=ncid{'time'}(:);
   Latitude=ncid{'lat'}(:);
   Longitude=ncid{'lon'}(:);
end
% récupération des données de précipitation et restriction dans notre domaine d'étude
if netcdf_open_available
   startlat=find(Latitude>=latmin,1);
   countlat=find(Latitude<=latmax,1,'last')-startlat+1;
   startlon=find(Longitude>=lonmin,1);
   countlon=find(Longitude<=lonmax,1,'last')-startlon+1;
   Latitude = Latitude(Latitude >= latmin & Latitude <= latmax);
   Longitude = Longitude(Longitude >= lonmin & Longitude <= lonmax);
   clear lonmin
   clear lonmax
   clear latmin
   clear latmax
% récupération des données de précipitation dans le domaine
   PPT=netcdf.getVar(ncid,11,[startlon-1 startlat-1 0]);
   [countlon countlat size(Temps,1)];
   clear countlat
   clear countlon
   clear startlat
   clear startlon
   PPT=double(PPT);
   %
   % permute to output array with
   % dimension 1 : temps, dimension 2 : lat, dimension 3 :lon
   PPT = permute(PPT,[3 1 2]);
 
else
   indlat=find(Latitude>=latmin & Latitude<=latmax);
  % countlat=find(Latitude<=latmax,1,'last')-startlat+1;
   indlon=find(Longitude>=lonmin & Longitude<=lonmax);
   %countlon=find(Longitude<=lonmax,1,'last')-startlon+1;
   Latzone = Latitude(indlat);
   Longzone = Longitude(indlon);
   %Latitude = Latitude(Latitude >= latmin & Latitude <= latmax);
   %Longitude = Longitude(Longitude >= lonmin & Longitude <= lonmax);
   PPT=ncid{'ppt'}(:,indlat,indlon);
  % disp(['iii: taille ppt'])
  % size(PPT)
end
if netcdf_open_available
   netcdf.close(ncid);
end
clear ncid
%selection de la saison des pluies
ind_date=find(Temps>=datenum(annee,6,1)&Temps<=datenum(annee,11,30));

nb_day=size(ind_date);
nlat=size(indlat);
nlon=size(indlon);
ppt_moy=zeros(nlat,nlon);
ppt_esp=zeros(1,nb_day);
for j=1:nlat;
    for i=1:nlon;
        ppt_esp(:)=PPT(ind_date,j,i);
       ppt_moy(j,i)=mean(ppt_esp(:));
       ppt_ecartyp(j,i)=std(ppt_esp(:));
    end
end
ifigure=gcf()+1;
figure(ifigure);
subplot1(1,2,'Gap',[0.05 0.05],'XTickL','All','YTickL','Margin')
subplot1(1)
image3B42=imagesc( Longzone, Latzone, ppt_moy);
%colorbar;
colorbar("SouthOutside")
% pour l'inversion de l'axe des ordonnées y (origine en bas à
% gauche, valeurs Y croissantes de bas en haut (par defaut)
axis('xy');
%ppt_moy=peaks(latmax);
%pcolor(ppt_moy);
axis([lonmin lonmax latmin latmax])

%title('PPT Moyenne 2000-2009','fontsize',14);
montitre=sprintf('ppt_moyenne : %s\n',ppt_moy);
montitre=[montitre sprintf('Annee : %d\n',annee)];
montitre=[montitre sprintf('PPT Moyenne')];
title(montitre,'interpreter', 'none');
xlabel('Longitude','fontsize',14);
ylabel('Latitude','fontsize',14);
%set(gca,'ytick',[13:0.5:17])
subplot1(2)
%title('PPT Ecartype 2000-2009','fontsize',14)
montitre=sprintf('ppt_ecartyp : %s\n',ppt_ecartyp);
montitre=[montitre sprintf('Annee : %d\n',annee)];  
montitre=[montitre sprintf('PPT Ecart Type')];
title(montitre,'interpreter', 'none');
image3B42=imagesc( Longzone, Latzone, ppt_ecartyp);
%colorbar;
colorbar("SouthOutside")
%title('Ecart Type PPT en 2008','fontsize',14)
% pour l'inversion de l'axe des ordonnées y (origine en bas à
% gauche, valeurs Y croissantes de bas en haut (par defaut)
axis('xy');
%title('Variabilite Espatiale PPT moyenne Ferlo (2008)');
%figure=1;
%xdata=Temps
%disp(['iii: taille xdata'])
 %  size(xdata)
  % xticklabel=datestr(xdata,'yyyymmdd')

%plot(xdata, ppt_moy,'linewidth',2);
% set(gca,'xtick',xdata);
% set(gca,'xticklabel',xticklabel);
%ylim([0 110])
%xlim([0 370])
%title('Moyennes Journaliere ppt')
xlabel('Longitude','fontsize',14);
%ylabel('Latitude','fontsize',14);
%grid on
%legend('precipitation moyenne')



