function [result] = presentation_lpao()

%
%+
%
% ===================
% presentation_lpao.m
% ===================
%
% .. function:: presentation_lpao()
%
% DESCRIPTION
% ===========
%
% produit des figures utilises par :file:`presentation_lpao.tex`
%
% EXAMPLES
% ========
%
% Voir la 'demo'.
%
% SEE ALSO
% ========
%
% :ref:`presentation_lpao.sh`
%
% :file:`presentation_lpao.tex`
%
% :func:`read_lai_gis`
% :func:`plot_lai_gis`
%
% TODO
% ====
%
% check/complete list of call to plot_lai_gis
%
% missing data files to run completly : test with fake data
%
% handling errors
%
% EVOLUTIONS
% ==========
%
% $Id$
%
% $URL$
%
% - fplod 20110921T131301Z cratos (Linux)
%
%   * creation
%
%-
result=-1;
%
usage='[result] = presentation_lpao()';
if nargin~=nargin(mfilename)
   disp(['Incorrect number of input arguments ' num2str(nargin)]);
   error(usage)
end
%
if nargout ~= nargout(mfilename)
   disp(['Incorrect number of output arguments ' num2str(nargout)]);
   error(usage);
end

yyyy = uint16(2008);
seuil = uint16(100);
imageprefix='lai_2008_';

% read data ferlo 2008
zi_code = 'ferlo';
nbligne = uint16(0);
[lon_value, lat_value, datejul_value, datestr_value, lai_value, classes_value, msdnom_value] = read_lai_gis(yyyy, nbligne, zi_code);
%
msdnom_select = '';
%
classes_select = '"Savane herbacee et arbustive"';
[lai_mean, lai_std] = plot_lai_gis(datejul_value, datestr_value, lai_value, classes_value, msdnom_value, classes_select, msdnom_select, zi_code, imageprefix, seuil);
%
classes_select = '"Savane arboree"';
[lai_mean, lai_std] = plot_lai_gis(datejul_value, datestr_value, lai_value, classes_value, msdnom_value, classes_select, msdnom_select, zi_code, imageprefix, seuil);
%
classes_select = '"Steppe herbacee et arbustive"';
[lai_mean, lai_std] = plot_lai_gis(datejul_value, datestr_value, lai_value, classes_value, msdnom_value, classes_select, msdnom_select, zi_code, imageprefix, seuil);
%
classes_select = '"Savane  arbustive boisee"';
[lai_mean, lai_std] = plot_lai_gis(datejul_value, datestr_value, lai_value, classes_value, msdnom_value, classes_select, msdnom_select, zi_code, imageprefix, seuil);
%
classes_select = '"Savane herbacee arboree"';
[lai_mean, lai_std] = plot_lai_gis(datejul_value, datestr_value, lai_value, classes_value, msdnom_value, classes_select, msdnom_select, zi_code, imageprefix, seuil);
%
classes_select = '"Zones de cultures"';
[lai_mean, lai_std] = plot_lai_gis(datejul_value, datestr_value, lai_value, classes_value, msdnom_value, classes_select, msdnom_select, zi_code, imageprefix, seuil);
%
[lai_mean, lai_std] = plot_lai_gis(datejul_value, datestr_value, lai_value, classes_value, msdnom_value, classes_select, msdnom_select, zi_code, imageprefix, seuil);
%
% read data ferlo 2000-2008 to plot savane_arbustive_arboree figure
nbligne = uint16(0);
zi_code = 'ferlo';
msdnom_select = '';
for yyyy_d=2000:2008
    yyyy=uint16(yyyy_d);
    imageprefix=['lai_' int2str(yyyy) '_'];
    [lon_value, lat_value, datejul_value, datestr_value, lai_value, classes_value, msdnom_value] = read_lai_gis(yyyy, nbligne, zi_code);
    %
    classes_select = '"Savane arbustive arboree"';
    [lai_mean, lai_std] = plot_lai_gis(datejul_value, datestr_value, lai_value, classes_value, msdnom_value, classes_select, msdnom_select, zi_code, imageprefix, seuil);
    %
end
result=0;

end

%
%!demo
%! close all
%! clear all
%! varamma_startup;
%! more off
%! [result] = presentation_lpao();
