function[mat_3D,jours,lat ,lon]=readAMSU_clim(file,z_deb, z_fin,chemin)

%+
%
% ===============
% readAMSU_clim.m
% ===============
%
% .. function:: readAMSU_clim(file,z_deb, z_fin,chemin)
%
% DESCRIPTION
% ===========
%
% routine de lecture d un fichier de donnees AMSU au format netcdf
%
% EVOLUTIONS
% ==========
%
% $Id: readAMSU_clim.m 325 2011-08-04 15:30:01Z pinsard $
%
% $URL$
%
% - nclod 
%
%   * simplification du seuillage et de la  mise sous forme mat_3D(lat,lon, jours)
% - fplod 20110705T125628Z cratos.locean-ipsl.upmc.fr (Linux)
%
%   * minimal header
%
%-
usage='[mat_3D,jours,lat ,lon]=readAMSU_clim(file,z_deb, z_fin,chemin)';
if(nargin<2)
z_deb=[ -30 -60 datenum(1957,1,2)]  
end
if(nargin<3)
z_fin=[ 45 50 datenum(2020,1,1)]   
end

if(nargin<4)
     chemin='/homedata/eymard/AMSUAB/';
end
%
if nargout ~= nargout(mfilename)
   disp(['Incorrect number of output arguments ' num2str(nargout)]);
   error(usage);
end
if(chemin(end)~='/')
chemin=[chemin,'/'];
end

file=[chemin,file];
%% on stocke le canal dans la variable string

nc=netcdf(file,'nowrite');
longitude=nc{'xlon'}(:);
latitude=nc{'ylat'}(:);
jours=nc{'jours'}(:);

%jours=jours/24+datenum(1957,01,01); % En jours juliens
%jo=find(jours>z_deb(3) & jours<z_fin(3));
%jours=jours(jo);

la=find(latitude>z_deb(1) & latitude<z_fin(1));
lat=latitude(la);

lo=find(longitude>z_deb(2) & longitude<z_fin(2));
lon=longitude(lo);



temperature=squeeze(nc{'moyenne_tb'}(1:lenght(jours),la,lo));


%% mat_3D est la matrice (lat,lon,jours) que l''on utilise par la suite
mat_3D=permute(temperature,[2 3 1]);

%% On realise un seuillage qui optimise l''affichage
%% des donnees peu traitees.
mat_3D(find((mat_3D>300)|(mat_3D<140)))=NaN;  
