function [result]=sygmoide()

%+
%
% ==========
% sygmoide.m
% ==========
%
% .. function:: sygmoide()
%
% TODO
% =====
%
% dupe of sigmoide2.m ?
%
% EVOLUTIONS
% ==========
% 
% $Id$
%
% $URL: svn+ssh://pinsard@forge.ipsl.jussieu.fr/ipsl/forge/projets/varamma/svn/trunk/src/sigmoide2.m $
%
% - fplod 20110705T134725Z aedon.locean-ipsl.upmc.fr (Darwin)
%
%   * correction header (chapter level)
%
% - soclod ?
%
%   * charger les donnees datelai.csv sous format d'une ligne qui
%     contient les jours de l'annee
%   * definition manuelle des parametres d'ajustement pour les deux branches 
%     de la fonction (mc,nc,md,et nd)
%   * definition des indices correspondant  l'amplitude total et la
%     faible valeur du LAI  
%   * description deux branches de la fonction sigmode, se basant
%     sur l'evolution du LAI pour boucler sur les numeros de dates 
%
%-

result=[];

%clear all
%close all
% date=load('datelai.csv');
% ifigure=1;
% figure(ifigure);
global PROJECT_ID
% build the datelai filename to be read
fullfilename=[PROJECT_ID  'datelai.csv'];
disp(['iii : opening for reading ', fullfilename]);
% opening file
date=load(fullfilename);
clear fullfilename

nbdate=size(date,2);
% parametres d'ajustement correspondant  la croissance 
mc=30.11;
nc=0.13;
% les valeurs du LAI correspondant a l'amplitude totale et  la
% faible valeur 
a1c=1.34;
a2c=4.10;
% parametres d'ajustement de la branche correspondant  la decroissance
md=37.97;
nd=0.13;
%les valeurs du LAI correspondant a l'amplitude totale et  la
% faible valeur 
a1d=1.18;
a2d=4.25;
%j1=153;
%j2=281;
%j3=233;
%j4=361;
nbdate=45;

% initialisation des varaiables 
ac=zeros(nbdate);
ad=zeros(nbdate);
%for i=1:nbdate;
%indc=find((date == 153) & (date == 281));
%indd=find((date == 233) & (date == 361));
% description de la branche de la croissance de la fonction
% sigmode 
for i=20:35;
	ac(i)=((a1c+a2c*(1/(1+exp(mc-nc*date(i))))))/5;
end
% description de la branche de la decroissance de la fonction
% sigmode
for j=30:nbdate;
	ad(j)=(a1d+a2d*(1/(1+exp(-(md-nd*date(j))))))/5;
end

plot(date,ac,'rx');
hold on
plot(date,ad,'b*');
set(gca,'xtick',0:50:361)
xlim([0 361]);
xlabel('jours(2006)');
ylabel('LAI');
title('fonction sigmode');
%legend('lai','verdure ajustee','senescence ajuste');

result=0;
end
